public class GroveRotarySample{

	static {
		try {
			System.loadLibrary("javaupm_grove");
		}catch (UnsatisfiedLinkError e) {
			System.err.println("error in loading native library");
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) throws InterruptedException {
		upm_grove.GroveRotary knob = new upm_grove.GroveRotary(0);
	
		while (true) {
			float abs_value = knob.abs_value();	// Absolute raw value
			float abs_deg = knob.abs_deg();		// Absolute degrees
			float abs_rad = knob.abs_rad(); 	// Absolute radians
			float rel_value = knob.rel_value(); // Relative raw value
			float rel_deg = knob.rel_deg();		// Relative degrees
			float rel_rad = knob.rel_rad();		// Relative radians
			
			System.out.println( "Absolute: " + abs_value + " raw, " + abs_deg + " deg, " + abs_rad + " rad" );
			System.out.println( "Relative: " + rel_value + " raw, " + rel_deg + " deg, " + rel_rad + " rad" );
			
			Thread.sleep(3000);
		}
	}

}